<?php

namespace FreenetRouter\Libraries\ServiceManagers;

/**
 * @author Jakub Petržílka <kubapet@lbcfree.net>
 */
class AccountingServiceManager implements IServiceManager
{  
    public function isActive()
    {
        $result = exec("/usr/sbin/iptables -L -n | grep ACCOUNT");
        return (strpos($result,'ACCOUNT') !== false);
    }

    public function isEnabled()
    {
        $pom1 = false;
        $pom2 = false;
        $pom3 = false;
        if (($f = fopen("/etc/init.d/firewall","r"))) {
            while (!feof($f)) {        	    
                $value = preg_split("/[\ =\"\t\n]+/", fgets($f,1024));
                if (($value[0] == "ACCOUNT") && ($value[1] == "yes")) {
                    $pom1 = true;
                } else if (($value[0] == "ACCOUNT_GRAPHS") && ($value[1] == "yes")) {
                    $pom2 = true;
                } else if (($value[0] == "FIREWALL") && ($value[1] == "yes")) {
                    $pom3 = true;
                }
            }
            fclose($f);
        }
        if (is_link("/etc/rcS.d/S42firewall") && ($pom1) && ($pom2) && ($pom3)) {
            return true;
        }
        return false;
    }

    public function setActive(boolean $active)
    {
        if (($active)&&(!$this->isActive()))
        {
            exec("sudo /etc/init.d/firewall account_start");
        }
        else if ((!$active)&&($this->isActive()))
        {
            exec("/etc/init.d/firewall account_stop");
        }        
    }

    public function setEnabled(boolean $enabled)
    {
        $VALUE = $enabled ? "yes" : "no";
        
        if(($soubor = fopen("/tmp/firewall","w")))
        {
           if(($f = fopen("/etc/init.d/firewall","r")))
           {
               $pom1 = false;
               $pom2 = false;
               $pom3 = false;                   
                while (!feof($f)) {
                    $value = fgets($f,1024);
                    $value_array = preg_split("/[\ \"=\t\n]+/", $value);
                    $value_array_pom = preg_split("/[#\n]+/", $value);
                    if (($value_array[0] == "ACCOUNT") && (!$pom1)) {
                        fwrite($soubor,"ACCOUNT=\"".$VALUE."\"\t\t\t#".$value_array_pom[1]."\n");
                        $pom1 = true;
                    } else if (($value_array[0] == "ACCOUNT_GRAPHS") && (!$pom2)) {
                        fwrite($soubor,"ACCOUNT_GRAPHS=\"".$VALUE."\"\t\t#".$value_array_pom[1]."\n");
                        $pom2 = true;
                    } else if (($value_array[0] == "FIREWALL") && (!$pom3)) {
                        if ($VALUE == "yes") {
                            fwrite($soubor,"FIREWALL=\"yes\"\t\t\t#".$value_array_pom[1]."\n");
                        } else {
                            fwrite($soubor,$value);
                        }
                        $pom3 = true;
                    } else {
                        fwrite($soubor,$value);
                    }
                }
                fclose($f);
           }
            fclose($soubor);
            exec("sudo /bin/cp /tmp/firewall /etc/init.d/firewall");
        }
        if (!is_link("/etc/rcS.d/S42firewall") && ($pom1) && ($pom2) && ($pom3) && ($VALUE == "yes")) {
            exec("sudo /bin/ln -s ../init.d/firewall /etc/rcS.d/S42firewall");
        }
    }

}
