<?php

namespace FreenetRouter\Libraries\ServiceManagers;

/**
 * @author Jakub Petržílka <kubapet@lbcfree.net>
 */
class DHCPServerManager implements IServiceManager
{  
    public function isActive()
    {
        $result = exec("/etc/init.d/isc-dhcp-server status");
        return (strpos($result,'is running') !== false);
    }

    public function isEnabled()
    {
        return is_link("/etc/rc2.d/S18isc-dhcp-server");
    }

    public function setActive(boolean $active)
    {
        if (($active)&&(!$this->isActive()))
        {
            exec("sudo /etc/init.d/isc-dhcp-server start");
        }
        else if ((!$active)&&($this->isActive()))
        {
            exec("sudo /etc/init.d/isc-dhcp-server stop");
        }        
    }

    public function setEnabled(boolean $enabled)
    {
        $files = array("/etc/rc1.d/K02isc-dhcp-server",
            "/etc/rc2.d/S18isc-dhcp-server","/etc/rc3.d/S18isc-dhcp-server",
            "/etc/rc4.d/S18isc-dhcp-server","/etc/rc5.d/S18isc-dhcp-server");
        if ($enabled) {
            foreach ($files as $file) {
                exec("sudo /bin/ln -s ../init.d/isc-dhcp-server ".$file);
            }
        } else {
            exec("sudo /bin/rm -f ".implode(" ",$files));
        }
    }

}
