<?php

namespace FreenetRouter\Libraries\ServiceManagers;

/**
 * @author Jakub Petržílka <kubapet@lbcfree.net>
 */
class SSHServerManager implements IServiceManager
{  
    public function isActive()
    {
        $result = exec("/etc/init.d/ssh status");
        return (strpos($result,'is running') !== false);
    }

    public function isEnabled()
    {
        return is_link("/etc/rc2.d/S18ssh");
    }

    public function setActive(boolean $active)
    {
        if (($active)&&(!$this->isActive()))
        {
            exec("sudo /etc/init.d/ssh start");
        }
        else if ((!$active)&&($this->isActive()))
        {
            exec("sudo /etc/init.d/ssh stop");
        }        
    }

    public function setEnabled(boolean $enabled)
    {
        $files = array("/etc/rc2.d/S18ssh",
            "/etc/rc3.d/S18ssh","/etc/rc4.d/S18ssh","/etc/rc5.d/S18ssh");
        if ($enabled) {
            foreach ($files as $file) {
                exec("sudo /bin/ln -s ../init.d/ssh ".$file);
            }
        } else {
            exec("sudo /bin/rm -f ".implode(" ",$files));
        }      
    }

}
