<?php

namespace Phem\Core;

/**
 * Description of Object
 *
 * @author Vejvis
 */
abstract class Object
{

    /**
     * Returns property value. Do not call directly.
     * @param  string  property name
     * @return mixed   property value
     * @throws MemberAccessException if the property is not defined.
     */
    public function &__get($name)
    {
        return ObjectMixin::get($this, $name);
    }

    /**
     * Sets value of a property. Do not call directly.
     * @param  string  property name
     * @param  mixed   property value
     * @return void
     * @throws MemberAccessException if the property is not defined or is read-only
     */
    public function __set($name, $value)
    {
        return ObjectMixin::set($this, $name, $value);
    }

}