<?php

namespace Phem\Libraries\ImportExport\Json;

use JsonSerializable;
use Phem\Core\Object;

/**
 * @author Jakub Petržílka <petrzilka@czweb.net>
 */
abstract class JsonSerializableObject extends Object implements JsonSerializable
{

    public function jsonSerialize()
    {
        $result = array();

        foreach (get_class_methods($this) as $method)
        {
            
            /* if method starts with "get" consider it as getter */
            if (strpos($method, "get") === 0)
            {
                $propName = str_replace("get", "", $method);
                $propName{0} = strtolower($propName{0});
                $result[$propName] = json_encode($this->$method());
            }
        }

        return $result;
    }

}
