<?php

namespace Phem\Libraries\Security\Management;

use Phem\Libraries\Security\Model\Common\Group;
use Phem\Libraries\Security\Model\Common\User;

interface IUserManager
{

    public function addUser(User $user);

    public function removeUser(User $user);

    public function modifyUser(User $user);

    public function addGroup(Group $group);

    public function removeGroup(Group $group);

    public function modifyGroup(Group $group);

    public function addUserToGroup(Group $group, User $user);

    public function removeUserFromGroup(Group $group, User $user);

    public function getGroupsOf(User $user);

    public function getUsersOf(Group $group);

    public function getGroups(Group $prototype = null, $orderBy = null, $limit = null);

    public function getUsers(User $prototype = null, $orderBy = null, $limit = null);

    public function getGroup($name);

    public function getUser($username);

    public function isMemberOf(User $user, Group $group);
}