<?php

namespace Phem\Libraries\Security\Model\Common;

use Phem\Core\Object;
use Phem\Environment\EnvironmentManager;
use Phem\Libraries\Forms\Annotations\Input;
use Phem\Libraries\Forms\Annotations\Form;
use Phem\Libraries\Forms\Annotations\Group;

/**
 * @Form(defaultGroup="newController")
 * @Group(caption="Registrace kontroleru", name="newController")
 */
class Controller extends Object
{

    protected $id;
    /**
     * @Input(caption="Název", type="text", maxlength=48)
     */
    protected $name;
    /**
     * @Input(caption="Popis", type="text", maxlength=256)
     */
    protected $description;

    public function getId()
    {
        return $this->id;
    }

    public function setId($id)
    {
        $this->id = $id;
    }

    public function getName()
    {
        return $this->name;
    }

    public function setName($name)
    {
        $this->name = $name;
    }

    public function getDescription()
    {
        return $this->description;
    }

    public function setDescription($description)
    {
        $this->description = $description;
    }
    
    public function getAvailableTasks()
    {
        return EnvironmentManager::getTaskManager()->getAvailableTasksOfController($this);
    }

    public function getRegisteredTasks()
    {
        return EnvironmentManager::getTaskManager()->getRegisteredTasksOfController($this);
    }
    
}