<?php

namespace Phem\Libraries\Security\Model\MySQL;

use Doctrine\ORM\Mapping\OneToMany;
use Phem\Libraries\Security\Model\Common\Controller as CommonController;

/**
 * @Entity @Table(name="admin_controller") 
 */
class Controller extends CommonController
{

    /** @Id @Column(type="integer") @GeneratedValue */
    protected $id;

    /** @Column(type="string") */
    protected $name;

    /** @Column(type="string") */
    protected $description;

    /**
     * @OneToMany(targetEntity="Permission", mappedBy="controller",cascade={"all"})
     */
    protected $permissions;

    public function getPermissions()
    {
        return $this->permissions;
    }

    public function setPermissions($permissions)
    {
        $this->permissions = $permissions;
    }

    public function getId()
    {
        return $this->id;
    }

    public function setId($id)
    {
        $this->id = $id;
    }

    public function getName()
    {
        return $this->name;
    }

    public function setName($name)
    {
        $this->name = $name;
    }

    public function getDescription()
    {
        return $this->description;
    }

    public function setDescription($description)
    {
        $this->description = $description;
    }

}