<?php

namespace Phem\Libraries\Security\Model\MySQL;

use Doctrine\ORM\Mapping\JoinColumn;
use Doctrine\ORM\Mapping\ManyToOne;
use Phem\Libraries\Security\Model\Common\Permission as CommonPermission;

/**
 * @Entity @Table(name="admin_permission") 
 */
class Permission extends CommonPermission
{

    /** @Id @Column(type="integer") @GeneratedValue */
    protected $id;

    /**
     * @ManyToOne(targetEntity="Controller")
     * @JoinColumn(name="controller", referencedColumnName="id") 
     */
    protected $controller;

    /**
     * @ManyToOne(targetEntity="Group")
     * @JoinColumn(name="groupId", referencedColumnName="id") 
     */
    protected $group;

    /**
     * @ManyToOne(targetEntity="Task")
     * @JoinColumn(name="task", referencedColumnName="id") 
     */
    protected $task;
    
    /** @Column(type="boolean") */    
    protected $type;

    public function getId()
    {
        return $this->id;
    }

    public function setId($id)
    {
        $this->id = $id;
    }

    public function getController()
    {
        return $this->controller;
    }

    public function setController($controller)
    {
        $this->controller = $controller;
    }

    public function getGroup()
    {
        return $this->group;
    }

    public function setGroup($group)
    {
        $this->group = $group;
    }

    public function getTask()
    {
        return $this->task;
    }

    public function setTask($task)
    {
        $this->task = $task;
    }

    public function getType()
    {
        return $this->type;
    }

    public function setType($type)
    {
        $this->type = $type;
    }

}