<?php

namespace Phem\Libraries\Security\Model\MySQL;

use Doctrine\ORM\Mapping\JoinColumn;
use Doctrine\ORM\Mapping\ManyToOne;
use Doctrine\ORM\Mapping\OneToMany;
use Phem\Libraries\Security\Model\Common\Task as CommonTask;

/**
 * @Entity @Table(name="admin_task") 
 */
class Task extends CommonTask
{

    /** @Id @Column(type="integer") @GeneratedValue */
    protected $id;

    /**
     * @ManyToOne(targetEntity="Controller",cascade={"all"})
     * @JoinColumn(name="controller", referencedColumnName="id") 
     */
    protected $controller;

    /** @Column(type="string") */
    protected $name;

    /** @Column(type="string") */
    protected $description;

    /**
     * @OneToMany(targetEntity="Permission", mappedBy="task",cascade={"all"})
     */
    protected $permissions;

    public function getId()
    {
        return $this->id;
    }

    public function setId($id)
    {
        $this->id = $id;
    }

    public function getController()
    {
        return $this->controller;
    }

    public function setController($controller)
    {
        $this->controller = $controller;
    }

    public function getName()
    {
        return $this->name;
    }

    public function setName($name)
    {
        $this->name = $name;
    }

    public function getDescription()
    {
        return $this->description;
    }

    public function setDescription($description)
    {
        $this->description = $description;
    }

    public function getPermissions()
    {
        return $this->permissions;
    }

    public function setPermissions($permissions)
    {
        $this->permissions = $permissions;
    }

}