<?php

namespace Phem\Libraries\UI\Model;

use JsonSerializable;

/**
 * @author Jakub Petržílka <petrzilka@czweb.net>
 */
class EventResult implements JsonSerializable
{

    private $changes;
    private $version;
    private $invokedBy;

    function __construct($changes, $version)
    {
        $this->changes = $changes;
        $this->version = $version;
    }

    public function getChanges()
    {
        return $this->changes;
    }

    public function getVersion()
    {
        return $this->version;
    }

    public function setChanges($changes)
    {
        $this->changes = $changes;
    }

    public function setVersion($version)
    {
        $this->version = $version;
    }
    
    public function getInvokedBy()
    {
        return $this->invokedBy;
    }

    public function setInvokedBy($invokedBy)
    {
        $this->invokedBy = $invokedBy;
    }

    public function jsonSerialize()
    {
        return [
            'changes' => $this->changes,
            'version' => $this->version,
            'invokedBy' => $this->invokedBy,
        ];
    }

}
