<?php

namespace Phem\Libraries\UI\Model;

/**
 * @author Jakub Petržílka <petrzilka@czweb.net>
 */
class Label extends Control
{
    /**
     *
     * @\Phem\Libraries\UI\Annotations\ContentAttr(name="label")
     */
    private $text;
    private $alignment;
    
    /**
     *
     * @\Phem\Libraries\UI\Annotations\StyleAttr(name="color")
     */
    private $color;
    
    /** @var Control */
    private $targetControl;
    
    public function getText()
    {
        return $this->text;
    }

    protected function setText($text)
    {
        $this->text = $text;
    }

    public function getValue()
    {
        return $this->getText();
    }

    protected function setValue($value)
    {
        $this->setText($value);
    }
    
    public function getAlignment()
    {
        return $this->alignment;
    }

    protected  function setAlignment($alignment)
    {
        $this->alignment = $alignment;
    }
    
    public function getColor()
    {
        return $this->color;
    }

    protected function setColor($color)
    {
        $this->color = $color;
    }
    
    /**
     * @return Control
     */
    public function getTargetControl()
    {
        return $this->targetControl;
    }

    protected function setTargetControl(Control $targetControl)
    {
        $this->targetControl = $targetControl;
    }

}
