<?php

namespace Phem\Libraries\UI\Model;

use Phem\Core\Collection;

/**
 * @author Jakub Petržílka <petrzilka@czweb.net>
 */
class SelectBox extends Control
{

    private $options;
    private $enabled = true;
    
    /**
     * @\Phem\Libraries\UI\Annotations\DomAttr(name="value")
     */
    private $selected;
    private $onChange;
    
    function __construct($parent)
    {
        parent::__construct($parent);
        $this->onChange = new Collection();
    }    

    public function getOptions()
    {
        return $this->options;
    }

    public function getSelected()
    {
        return $this->selected;
    }

    protected function setOptions($options)
    {
        $this->options = $options;
    }

    protected function setSelected($selected)
    {
        $this->selected = $selected;
    }


    public function getEnabled()
    {
        return $this->enabled;
    }

    protected function setEnabled($enabled)
    {
        $this->enabled = $enabled;
    }

    public function OnChange()
    {
        return $this->onChange;
    }

    public function getValue()
    {
        return $this->getText();
    }

    protected function setValue($value)
    {
        $this->setText($value);
    }

}
