<?php

/*
 * This file contains basic configuration of the framework.
 * In most cases there is no need for changes in this file unless
 * you want to modify framework core 
 * and maybe brake compatibility with the trunk.
 * 
 * All application specific settings can be done in application.conf.php.
 */

/* Directory separator */
if (!defined("DS"))
{
    define("DS", "/");
}

define("ABSOLUTE_PATH", __DIR__);

define("FRAMEWORK_EXEC", true);
define("ROOT_NAMESPACE", "Phem");
if(!defined("ROOT_DIR"))
{
    define("ROOT_DIR", '.');
}
define("FRAMEWORK_DIR", ROOT_DIR.DS."Framework");
/* Directory with 3rd party libraries */
define("THIRD_PARTY_DIR", FRAMEWORK_DIR . DS . "3rdParty");

/* Running environment directory */
if (!defined("RUN_DIR"))
{
    define("RUN_DIR", ROOT_DIR.DS.'Run');
}

/* Proxy directories */
define("PROXY_DIR", RUN_DIR . DS . 'Proxy');
define("DOCTRINE_PROXY_DIR", PROXY_DIR . DS . 'Doctrine');

/* Cache directories */
define("CACHE_DIR", RUN_DIR . DS . 'Cache');
define("TEMPLATE_CACHE_DIR", CACHE_DIR . DS . 'Twig');

define("CONTROLLER_SUFFIX", "Controller");
define("CONTROLLER_ROUTE_ATTR", "controller");
define("TASK_ROUTE_ATTR", "task");

define("DISPATCHER_CONTROLLER_NAME", "Dispatcher");
define("DISPATCHER_LOGIN_TASK_NAME", "login");
define("DISPATCHER_DENIED_ACCESS_TASK_NAME", "showAccessDenied");

define("BOOTSTRAPER_SUFFIX", "Boot");
define("RESOURCELOADER_SUFFIX", "Loader");

define("BUILTIN_RESOURCES_DIR", 'Resources');
define("BUILTIN_TEMPLATES_DIR", 'templates');
define("BUILTIN_CSS_DIR", 'css');
define("BUILTIN_JS_DIR", 'javascript');
define("BUILTIN_THIRD_PARTY_RES_DIR", '3rdParty');\

define("BUILTIN_TEMPLATES_NAMESPACE", 'Phem');

if (array_key_exists("HTTP_HOST",$_SERVER))
{
    define("HOST_URL","http://".$_SERVER["HTTP_HOST"]);
}
else
{
    define("HOST_URL","http://localhost");
}